import es
import playerlib
import popuplib
import usermsg
import gamethread

from configobj import ConfigObj

import random

#Config Part fuer das Counter Model im Terror bereich
ctmodel = 0

#Klassen  

class MapManager(object):
    def __init__(self):
        pass
		
    def remove(self):
        index = es.createentitylist('hostage_entity')
        for i in index:
            es.server.queuecmd('es_xremove %s' %(i))
        
class DownloadManager(object):
    def __init__(self):
        self.downloads = []
        
    def add(self, path):
        if not path in self.downloads:
            self.downloads.append(path)
        
    def remove(self, path):
        try:
            self.downloads.remove(path)
        except:
            pass  
                      
    def activate(self):
        for i in self.downloads:
            es.stringtable('downloadables', i)      
            
class Clock(object):
    def __init__(self):
        self.time = float(es.ServerVar('mp_roundtime'))*60
        self.userids = []
        
    def start(self):
        gamethread.delayedname(1, 'clockTimer', self.tick, ())
        self.time = float(es.ServerVar('mp_roundtime'))*60
        
    def stop(self):
        self.time = 0
        gamethread.cancelDelayed('clockTimer')
        
    def tick(self):
        gamethread.delayedname(1, 'clockTimer', self.tick, ())
        self.time -= 1
        if self.time == 0:
            self.stop()
        
    def getTime(self):
        return self.time
        
    def add(self, userid):
        if userid not in self.userids:
            self.userids.append(userid)
            
    def remove(self, userid):
        if userid in self.userids:
            self.userids.remove(userid)
            usermsg.hudhint(userid, '')
            
    def send(self):
        for i in self.userids:
            min = int(self.getTime()//60)
            sec = int(self.getTime()%60)
            if sec <= 9:
                sec = '0%s' %(sec)
            usermsg.hudhint(i, 'Time left:\n%s:%s' %(min, sec))
            
class TickManager(object):
    def __init__(self):
        self.tickEnabled = False
        
    def enable(self):
        if not self.tickEnabled:
            es.addons.registerTickListener(tickListener)
            loop()
            self.tickEnabled = True
            
    def disable(self):
        if self.tickEnabled:
            es.addons.unregisterTickListener(tickListener)
            gamethread.cancelDelayed('sseekLoop')
            self.tickEnabled = False
            
    def isEnabled(self):
        return self.tickEnabled                
		
class Player(object):
    def __init__(self, userid):
        self.userid = userid
        self.player = playerlib.getPlayer(userid) 
        self.team = es.getplayerteam(userid)
        self.alive = False
        self.thirdView = False
        self.solidStatus = True
        self.freezeStatus = False
        self.valuesOK = False
        self.valueList = []
        self.configPopupSend = False
        self.whistle = 0
        self.weapons = 0
        self.color = 0
        self.model = None
        self.ct = False
        self.ready = False
        
        gamethread.delayed(1, self.isReady, ())
        
    def isReady(self):
        self.ready = True
        
    def changeTeam(self, index):
        self.team = int(index)
        if self.team in (2,3):
            cnt = 0
            for i in checkValues:
                cnt += 1
                gamethread.delayed(0.05*cnt, self.checkSettings, (i))
        
    def death(self):
        self.alive = False
        self.firstPerson()
        self.solid()
        self.unfreeze()
        
    def itemPickup(self, item):
        if self.team == 2:
            if not self.ct or item != 'usp':
                self.removeWeapons() 
            elif item == 'usp':
                gamethread.delayed(0.5, self.player.setClip, ('weapon_usp', 0))
                gamethread.delayed(0.5, self.player.setAmmo, ('weapon_usp', 0)) 				
        elif self.team == 3:
            if item in ('hegrenade', 'flashbang', 'smokegrenade'):
                index = self.player.getWeaponIndex('weapon_%s' %(item))
                es.server.queuecmd('es_xremove %s' %(index))
                es.cexec(self.userid, 'lastinv')      
                
    def weaponFire(self):
        hp = self.player.getHealth() - 4
        if hp <= 0:
            es.server.queuecmd('damage %s %s' %(self.userid, self.player.getHealth()))
        else:
            self.player.setHealth(hp)  
            
    def say(self, text):
        if self.alive:
            if self.team == 2:
                if text == '+3rd':
                    self.thirdPerson()
                elif text == '-3rd':   
                    self.firstPerson()
                elif text == '+solid':
                    self.solid()
                elif text == '-solid':  
                    self.nonSolid()
                elif text == '+freeze':
                    self.freeze()
                elif text == '-freeze':
                    self.unfreeze()    
                elif text == '!whistle':
                    if self.whistle < 3:
                        whistle.play(self.userid)
                        self.whistle += 1
                elif text == '+color':
                    if self.color < 140:
                        self.color += 20
                        self.player.setColor(255 - self.color, 255 - self.color, 255 - self.color, 255)
                    else:
                        tell(self.userid, 'Du hast die maximale Dunkelheit erreicht!')
                elif text == '-color':
                    if self.color > 0:
                        self.color -= 20
                        self.player.setColor(255 - self.color, 255 - self.color, 255 - self.color, 255)
                    else:
                        tell(self.userid, 'Du hast die maximale Helligkeit erreicht!')  
                elif text == '!model':
                    tell(self.userid, 'Dein Model: %s' %(self.model))
                elif text == '!t':
                    infoPopup.sendTPopup(self.userid)
            elif self.team == 3:
                if text == '!waffen':
                    if self.weapons < 2:
                        gunPopup.send(self.userid)   
                elif text == '!ct':
                    infoPopup.sendCTPopup(self.userid)     
        if text == '!cfg' and not self.configPopupSend: 
            infoPopup.sendConfigPopup(self.userid)
            self.configPopupSend = True         
            
    def removeWeapons(self):
        es.server.queuecmd('es_give %s player_weaponstrip' %(self.userid))
        es.server.queuecmd('es_fire %s player_weaponstrip strip' %(self.userid))
        if self.ct:  
            try:
                es.server.queuecmd('es_xgive %s weapon_usp' %(self.userid))
                gamethread.delayed(0.5, self.player.setClip, ('weapon_usp', 0))
                gamethread.delayed(0.5, self.player.setAmmo, ('weapon_usp', 0)) 
            except:
                pass
                   
    def prepare(self):
        es.server.queuecmd('es_xfire %s func_buyzone disable' %(self.userid)) 
        es.server.queuecmd('es_xfire %s func_breakable break' %(self.userid)) 
        es.server.queuecmd('es_xfire %s func_breakable_surf break' %(self.userid)) 
        
        self.whiste = 0
        self.weapons = 0
        self.color = 0
        self.model = None
        self.ct = False
        
        self.firstPerson()
        self.solid()
        self.unfreeze()  
        
        if self.team == 2:
            self.prepareHide()
        elif self.team == 3:
            self.prepareSeek()
        self.alive = True           
        
    def prepareHide(self):
        self.removeWeapons()
        
        if curMap in modellist:       
            tmp = random.randint(1, len(modellist[curMap].keys()))
            self.player.setModel(modellist[curMap][tmp][1])
            tell(self.userid, 'Dein neues Model: %s' %(modellist[curMap][tmp][0]))
            self.model = modellist[curMap][tmp][0] 
        
        self.player.setSpeed(1.3)
            
    def prepareSeek(self):    
        usermsg.fade(self.userid, 1, 2, 15050, 2, 2, 2, 255)
        self.player.freeze(1)
        gamethread.delayed(31, self.player.freeze, (0))
        self.player.setColor(255,255,255,255)
        
    def thirdPerson(self):
        if not self.thirdView:
            es.setplayerprop(self.userid, 'CBasePlayer.m_hObserverTarget', 0)
            es.setplayerprop(self.userid, 'CBasePlayer.m_iObserverMode', 1)
            es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_Local.m_bDrawViewmodel', 0)
            es.setplayerprop(self.userid, 'CBasePlayer.m_iFOV', 100)
            clock.add(self.userid)
            self.thirdView = True
            tell(self.userid, 'Dritte Person: Aktiviert')
            
    def firstPerson(self):
        if self.thirdView:
            es.setplayerprop(self.userid, 'CCSPlayer.baseclass.m_hObserverTarget', 0)
            if self.alive:
                es.setplayerprop(self.userid, 'CBasePlayer.m_iObserverMode', 0)
                es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_Local.m_bDrawViewmodel', 1)
                es.setplayerprop(self.userid, 'CBasePlayer.m_iFOV', 90)  
            clock.remove(self.userid)
            self.thirdView = False
            tell(self.userid, 'Dritte Person: Deaktiviert')
                
    def nonSolid(self):
        if self.solidStatus:
            es.setplayerprop(self.userid, 'CBaseEntity.m_CollisionGroup', 2) 
            self.solidStatus = False  
            tell(self.userid, 'NoBlock: Aktiviert')
            
    def solid(self):
        if not self.solidStatus:
            es.setplayerprop(self.userid, 'CBaseEntity.m_CollisionGroup', 5) 
            self.solidStatus = True  
            tell(self.user, 'NoBlock: Deaktiviert')
            
    def freeze(self):
        if not self.freezeStatus:
            es.setplayerprop(self.userid, 'CBasePlayer.m_fFlags', 66172)
            es.setplayerprop(self.userid, 'CBaseEntity.movetype', 0)
            self.freezeStatus = True
            tell(self.userid, 'Freeze: Aktiviert')
            
    def unfreeze(self):
        if self.freezeStatus:
            es.setplayerprop(self.userid, 'CBasePlayer.m_fFlags', 32)
            es.setplayerprop(self.userid, 'CBaseEntity.movetype', 2)
            self.freezeStatus = False  
            tell(self.userid, 'Freeze: Deaktiviert')
                
    def checkSettings(self, val):
        if self.ready:
            es.queryclientvar(self.userid, val)
            
    def addValue(self, value):     
        if not value in self.valueList:
            self.valueList.append(value)
            if len(self.valueList) == len(checkValues):
                self.valuesOK = True  
            
    def removeValue(self, value):
        if value in self.valueList:
            self.valueList.remove(value)
        if self.team != 1:
            es.server.queuecmd('es_xchangeteam %s 1' %(self.userid))
            tell(self.userid, 'Deine Werte stimmen nicht! Bitte sieh in der Konsole oder dem Popup nach, wie du sie aendern kannst.')
        self.valuesOK = False
        if not self.configPopupSend:
            infoPopup.sendConfigPopup(self.userid)
            self.configPopupSend = True
            
    def getValueStatus(self):
        return self.valuesOK   
        
    def configPopupClosed(self):
        self.configPopupSend = False 
        
    def gotWeapon(self):
        self.weapons += 1
        
    def damageDucked(self):
        if self.player.isDucked():
            hp = self.player.getHealth() - 10
            if hp <= 0:
                es.server.queuecmd('damage %s %s' %(self.userid, self.player.getHealth()))
            else:
                self.player.setHealth(hp)  
            msg('%s ist zu feige wie ein Mann zu spielen! Er duckt sich lieber!' %(es.getplayername(self.userid)))  
            
    def setCT(self):
        self.ct = True
        self.player.setModel('player/ct_gsg9')
        es.server.queuecmd('es_xgive %s weapon_usp' %(self.userid))
        gamethread.delayed(0.1, self.player.setClip, ('weapon_usp', 0))
        gamethread.delayed(0.1, self.player.setAmmo, ('weapon_usp', 0)) 
        tell(self.userid, 'Du bist nun ein CT, versuche nicht aufzufallen.')
        self.model = 'CT'   
        
class Playerlist(object):
    def __init__(self):
        self.players = {}
        
    def __getitem__(self, key):
        try:
            return self.players[int(key)]
        except:
            return None
        
    def add(self, userid):
        userid = int(userid)
        self.players[userid] = Player(userid)
        
    def remove(self, userid):
        userid = int(userid)
        del self.players[userid]
                              
    def checkSettings(self, val):
        for i in self.players:
            try:
                self.players[i].checkSettings(val)
            except: 
                pass
            
    def damageDucked(self):
        for i in playerlib.getUseridList('#t, #alive'):
            self.players[i].damageDucked()
            
class GunPopup(object):
    def __init__(self):
        if popuplib.exists('sseekGunMainMenu'):
            popuplib.delete('sseekGunMainMenu')      
        self.main = popuplib.create('sseekGunMainMenu')
        self.main.addline('Waffen Menu:')
        self.main.addline('->1. Pistols')
        self.main.addline('->2. Shotguns')
        self.main.addline('->3. SMGs')
        self.main.addline('->4. Rifles')
        self.main.addline(' ')
        self.main.addline('0. Schliessen')
        self.main.menuselect = self.mainChoice
      
        if popuplib.exists('sseekGunPistolMenu'):
            popuplib.delete('sseekGunPistolMenu')   
        self.pistol = popuplib.create('sseekGunPistolMenu')
        self.pistol.addline('Pistolen Menu:')
        self.pistol.addline('->1. Glock')
        self.pistol.addline('->2. USP')
        self.pistol.addline('->3. P228')
        self.pistol.addline('->4. Deagle')
        self.pistol.addline('->5. Dual Elite')
        self.pistol.addline('->6. Fiveseven')
        self.pistol.addline(' ')
        self.pistol.addline('->8. Zurueck')
        self.pistol.addline('0. Schliessen')
        self.pistol.menuselect = self.pistolChoice
        
        if popuplib.exists('sseekGunShotgunMenu'):
            popuplib.delete('sseekGunShotgunMenu')   
        self.shotgun = popuplib.create('sseekGunShotgunMenu') 
        self.shotgun.addline('Shotgun Menu:')
        self.shotgun.addline('->1. M3')
        self.shotgun.addline('->2. XM1014')
        self.shotgun.addline(' ')
        self.shotgun.addline('->8. Zurueck')
        self.shotgun.addline('0. Schliessen')  
        self.shotgun.menuselect = self.shotgunChoice
        
        if popuplib.exists('sseekGunSMGMenu'):
            popuplib.delete('sseekGunSMGMenu')   
        self.smg = popuplib.create('sseekGunSMGMenu')  
        self.smg.addline('SMG Menu:')
        self.smg.addline('->1. Mac10')
        self.smg.addline('->2. TMP')
        self.smg.addline('->3. MP5')
        self.smg.addline('->4. UMP')
        self.smg.addline('->5. P90')
        self.smg.addline(' ')
        self.smg.addline('->8. Zurueck')
        self.smg.addline('0. Schliessen')
        self.smg.menuselect = self.smgChoice
	
	
        if popuplib.exists('sseekGunRifleMenu'):
            popuplib.delete('sseekGunRifleMMenu')   
        self.rifle = popuplib.create('sseekGunRifleMMenu')
        self.rifle.addline('Rifle Menu:')
        self.rifle.addline('->1. Galil')
        self.rifle.addline('->2. Famas')
        self.rifle.addline('->3. AK47')
        self.rifle.addline('->4. M4A1')
        self.rifle.addline('->5. SG552')
        self.rifle.addline('->6. AUG')
        self.rifle.addline(' ')
        self.rifle.addline('->8. Zurueck')
        self.rifle.addline('0. Schliessen')
        self.rifle.menuselect = self.rifleChoice
        
    def mainChoice(self, userid, choice, id):
        if choice == 1:
            self.pistol.send(userid)   
        elif choice == 2:
            self.shotgun.send(userid)  
        elif choice == 3:
            self.smg.send(userid)  
        elif choice == 4:
            self.rifle.send(userid)  
        elif choice != 10:
            self.main.send(userid)
        
    def pistolChoice(self, userid, choice, id):
        weapons = ('glock', 'usp', 'p228', 'deagle', 'elite', 'fiveseven')
        if choice in (1,2,3,4,5,6):
            player = playerlib.getPlayer(userid)
            weapon = player.getSecondary()
            if weapon != 0: 
                index = player.getWeaponIndex(weapon)
                es.server.queuecmd('es_xremove %s' %(index))
            es.server.queuecmd('es_xgive %s weapon_%s' %(userid, weapons[choice-1]))
            playerlist[userid].gotWeapon()
        elif choice == 8:
            self.main.send(userid)
        elif choice != 10:
            self.pistol.send(userid)
        
    def shotgunChoice(self, userid, choice, id):
        weapons = ('m3', 'xm1014')
        if choice in (1,2):
            player = playerlib.getPlayer(userid)
            weapon = player.getPrimary()
            if weapon != 0: 
                index = player.getWeaponIndex(weapon)
                es.server.queuecmd('es_xremove %s' %(index))
            es.server.queuecmd('es_xgive %s weapon_%s' %(userid, weapons[choice-1]))
            playerlist[userid].gotWeapon()
        elif choice == 8:
            self.main.send(userid)
        elif choice != 10:
            self.shotgun.send(userid)
        
    def smgChoice(self, userid, choice, id):
        weapons = ('mac10', 'tmp', 'mp5navy', 'ump', 'p90')
        if choice in (1,2,3,4,5):
            player = playerlib.getPlayer(userid)
            weapon = player.getPrimary()
            if weapon != 0: 
                index = player.getWeaponIndex(weapon)
                es.server.queuecmd('es_xremove %s' %(index))
            es.server.queuecmd('es_xgive %s weapon_%s' %(userid, weapons[choice-1]))
            playerlist[userid].gotWeapon()
        elif choice == 8:
            self.main.send(userid)
        elif choice != 10:
            self.shotgun.send(userid)     
               
    def rifleChoice(self, userid, choice, id):
        weapons = ('galil', 'famas', 'ak47', 'm4a1', 'sg552', 'aug')
        if choice in (1,2,3,4,5,6):
            player = playerlib.getPlayer(userid)
            weapon = player.getPrimary()
            if weapon != 0: 
                index = player.getWeaponIndex(weapon)
                es.server.queuecmd('es_xremove %s' %(index))
            es.server.queuecmd('es_xgive %s weapon_%s' %(userid, weapons[choice-1]))
            playerlist[userid].gotWeapon()
        elif choice == 8:
            self.main.send(userid)
        elif choice != 10:
            self.rifle.send(userid) 
            
    def send(self, userid):
        self.main.send(userid)
        
class InfoPopup(object):
    def __init__(self):
        if popuplib.exists('sseekInfoConfig'):
            popuplib.delete('sseekInfoConfig')
        self.config = popuplib.create('sseekInfoConfig')           
        self.config.addline ('Config')
        self.config.addline ('----------')
        self.config.addline ('->1. cl_minmodels 0')
        self.config.addline ('Einstellbar in der Console')
        self.config.addline ('Minmodels alle: cl_minmodels 0')
        self.config.addline ('Nur ein Model pro Team: cl_minmodels 1')
        self.config.addline (' ')
        self.config.addline ('->2. cl_radaralpha 0')
        self.config.addline ('Einstellbar in der Console')
        self.config.addline ('Radar aus: cl_radaralpha 0')
        self.config.addline ('Radar an: cl_radaralpha 255')
        self.config.addline (' ')
        self.config.addline ('->3. r_shadows 0')
        self.config.addline ('Einstellbar in der Console')
        self.config.addline ('Schatten aus: r_shadows 0')
        self.config.addline ('Schatten an: r_shadows 1')
        self.config.addline ('----------')
        self.config.addline ('->0. Schliessen')   
        self.config.menuselect = self.configChoice
        
        if popuplib.exists('sseekInfoT'):
            popuplib.delete('sseekInfoT')
        self.t = popuplib.create('sseekInfoT')    
        self.t.addline ('SSeek - Terror')
        self.t.addline ('->1. +3rd')
        self.t.addline ('->2. -3rd')
        self.t.addline ('->3. +solid')
        self.t.addline ('->4. -solid')
        self.t.addline ('->5. !whistle')
        self.t.addline ('->6. +freeze')
        self.t.addline ('->7. -freeze')
        self.t.addline ('->8. +color')
        self.t.addline ('->9. -color')
        self.t.addline (' ')
        self.t.addline ('->0. Schliessen')
        self.t.menuselect = self.tChoice
        
        if popuplib.exists('sseekInfoCT'):
            popuplib.delete('sseekInfoCT')
        self.ct = popuplib.create('sseekInfoCT')    
        self.ct.addline ('SSeek - Counter')
        self.ct.addline ('->1. !waffen')
        self.ct.addline (' ')
        self.ct.addline ('->0. Schliessen')
        self.ct.menuselect = self.ctChoice
        
    def configChoice(self, userid, choice, id):
        if choice not in (1,2,3,10):
            self.config.send(userid)
        else:
            playerlist[userid].configPopupClosed()       
            
    def tChoice(self, userid, choice, id):
        commands = ('+3rd', '-3rd', '+solid', '-solid', '!whistle', '+freeze', '-freeze', '+color', '-color')
        if choice in (1,2,3,4,5,6,7,8,9):
            es.sexec(userid, 'say %s' %(commands[choice-1]))
        elif choice != 10:
            self.t.send(userid)
            
    def ctChoice(self, userid, choice, id):
        if choice == 1:
            es.sexec(userid, 'say !waffen')
        elif choice != 10:
            self.ct.send(userid)  
        
    def sendConfigPopup(self, userid):
        self.config.send(userid)      
        
    def sendTPopup(self, userid):
        self.t.send(userid) 
        
    def sendCTPopup(self, userid):
        self.ct.send(userid)           
        
class Whistle(object):
    def __init__(self):
        self.sounds = []
        
    def add(self, sound, name):
        if not (sound, name) in self.sounds:
            self.sounds.append((sound, name))
            downloadManager.add('sound/%s' %(sound))
		
    def play(self, userid):
        tmp = random.choice(self.sounds)
        es.emitsound('player', userid, tmp[0], 1.0, 0.7)
        msg('%s ,machte sich bemerkbar durch: %s' %(es.getplayername(userid), tmp[1]))

        
class MessageManager(object):
    def __init__(self):
        pass
        
    def start(self):
        for i in xrange(1,6):
            gamethread.delayedname(30 - i, 'sseekStart_%s' %(i), usermsg.centermsg, ('#all', 'Noch %s' %(i)))
        gamethread.delayedname(20, 'sseekStart_10', msg, ('Bereitet euch vor, in 10 Sekunden geht es los!'))
        gamethread.delayedname(30, 'sseekStart_0', msg, ('Die Sucher laufen nun los!')) 

    def stop(self):
        tmp = (0,1,2,3,4,5,10)
        for i in tmp:
            gamethread.cancelDelayed('sseekStart_%s' %(i))
                 
#Globale Variablen

configmaps = ConfigObj(es.getAddonPath('santasseek') + '/maps.txt')
modellist = {}
for x in configmaps.keys():
    modellist[x] = {}
    cnt = 1
    for y in configmaps[x]:
        modellist[x][cnt] = [y, configmaps[x][y]]
        cnt += 1

mapManager = MapManager()
downloadManager = DownloadManager()

clock = Clock()

tickManager = TickManager()

playerlist = Playerlist()
	
gunPopup = GunPopup()
infoPopup = InfoPopup()

whistle = Whistle()
whistle.add('santasseek/buzzer.mp3', 'Buzzer')
whistle.add('santasseek/caralarm.mp3', 'Alarm')
whistle.add('santasseek/cartoon.mp3', 'Und weg...')
whistle.add('santasseek/evillaugh.mp3', 'Evil Laugh')
whistle.add('santasseek/mammi.mp3', 'Mammi')
whistle.add('santasseek/mw.mp3', 'LAUT!!!')
whistle.add('santasseek/popi.mp3', 'Quietsch...')
whistle.add('santasseek/muahaha.mp3', 'Muahaha...')

messageManager = MessageManager()


curMap = None	

tickCounter = 0
checkValues = ['cl_radaralpha', 'r_shadows']

info = es.AddonInfo()
info.name = "Santas Seek"
info.version = "5.5"
info.author = "Santa"
info.url = "http://www.santa.eu.ki"
info.basename = "santasseek"
info.description = "Hide n Seek Mod fuer CSS"
info.copyright = "2010 - 2120"

#ES-Methoden

def load():
    global curMap 
    curMap = str(es.ServerVar('eventscripts_currentmap'))
	
    es.set("%s" % info.basename,info.version)
    es.makepublic("%s" % info.basename)
    
    es.server.queuecmd('eventscripts_noisy 1')
    
    es.set('mp_flashlight', 0)
    es.set('mp_freezetime', 3)
    es.set('mp_forcecamera', 0)
    es.set('sv_hudhint_sound', 0)
    es.set('mp_playerid', 1)
    es.set('sv_allowminmodels', 0)
    es.set('mp_unbalance_limit', 0)
        
    downloadManager.activate()
    
    es.addons.registerClientCommandFilter(clientCommand)
    
def unload():
    tickManager.disable()
    clock.stop()
        
    es.addons.unregisterClientCommandFilter(clientCommand)   
	
def es_map_start(ev):
    global curMap 
    curMap = str(es.ServerVar('eventscripts_currentmap'))
    
    downloadManager.activate()
    
def player_say(ev):
    playerlist[ev['userid']].say(ev['text'])
	
def round_start(ev):
    mapManager.remove()	    
    tickManager.enable()    
    messageManager.start()
    
def round_freeze_end(ev):
    clock.start()   
    
    if ctmodel:
        if random.choice((True, False, False, False, True)):
            playerlist[random.choice(playerlib.getUseridList('#t, #alive'))].setCT()
    
def round_end(ev):
    tickManager.disable()
    clock.stop()
    messageManager.stop()
    
    for i in playerlib.getPlayerList('#t,#alive'):
        es.server.queuecmd('score add %s 10' % i)
        msg('Alle ueberlebenden Hider bekommen, 10 Punkte!!!')
    
def player_spawn(ev):
    try:
        playerlist[ev['userid']].prepare()
    except:
        pass     
    
def player_death(ev):
    playerlist[ev['userid']].death()     
    
    if es.getplayerteam(ev['attacker']) == 3 and int(ev['attacker']) != int(ev['userid']):
        es.server.queuecmd('score add %s 2' % ev['attacker']) 
        
def player_hurt(ev):
    hp = playerlist[ev['attacker']].player.getHealth() + int(int(ev['dmg_health']) * 0.1)
    if hp > 100:
        hp = 100
    playerlist[ev['attacker']].player.setHealth(hp)
    
def player_activate(ev):
    playerlist.add(ev['userid']) 
    
def player_disconnect(ev):
    playerlist.remove(ev['userid'])  
    
    if es.getplayercount() == 0:                                  
        tickManager.disable()
    
def player_team(ev):     
    playerlist[ev['userid']].changeTeam(ev['team'])  
        
def item_pickup(ev):
    playerlist[ev['userid']].itemPickup(ev['item'])       
    
def weapon_fire(ev):
    playerlist[ev['userid']].weaponFire()      
    
def es_player_variable(ev):	
    if ev['variable'] in ('cl_radaralpha', 'cl_minmodels', 'r_shadows') and ev['status'] == 'success':
        if int(ev['value']) != 0:
            playerlist[ev['userid']].removeValue(ev['variable'])
            echo(ev['userid'], '%s muss den Wert 0 haben' %(ev['variable']))
        else:
            playerlist[ev['userid']].addValue(ev['variable'])

#Eigene Methoden

def tickListener():
    global tickCounter
    tickCounter += 1
    if tickCounter % 10 == 0:
        clock.send()
    if tickCounter % 50 == 0:
        playerlist.checkSettings(checkValues[tickCounter/50 - 1])  
        if tickCounter/50 == len(checkValues):  
            tickCounter = 0
            
def loop():
    gamethread.delayedname(2, 'sseekLoop', loop, ())
    playerlist.damageDucked()
            
def clientCommand(userid, command):
    if command[0] == 'jointeam':
        if not playerlist[userid].getValueStatus():
            if es.getplayercount() == 1 and not tickManager.isEnabled():
                tickManager.enable()
                tell(userid, 'Deine Werte wurden noch nicht ueberprueft! Bitte warte einen Moment')
            else:
                tell(userid, 'Deine Werte stimmen nicht! Bitte sieh in der Konsole oder dem Popup nach, wie du sie aendern kannst.')
            return False
        elif command[1] == '3':
            sizeT = int(es.getplayercount(2))
            sizeCT = int(es.getplayercount(3))  
            if sizeT <= 20 and sizeCT > 4:
                tell(userid, 'Das Sucher Team ist voll.')
                return False
            elif sizeT > 20 and sizeCT > 6: 
                tell(userid, 'Das Sucher Team ist voll.')
                return False
    return True
    
def msg(text):
    es.msg('#multi', '#green[S-Seek 5.5]#default %s' %(text))
    
def tell(userid, text):
    es.tell(userid, '#multi', '#green[S-Seek 5.5]#default %s' %(text))

def echo(userid, text):
    es.cexec(userid, 'echo', '[S-Seek 5.5] %s' %(text))       